/**
 * IOS 客户端的点击取词
 * To change this template use File | Settings | File Templates.
 */
(function() {
    'use strict';
    window.range = null;
    window.highlightNode =null;
    window.content = null;
    var targetTouch, //Touch point
        targetCoord = {}, //Current Touch events coordinates
        targetRealCoord = {}, // 目标位置修正，不用事件，改用range方法获取真实位置
        currentWord, //Word detected and waited to be looked up
        click, //click or tab
        driver,
        isDisabled = false, //为 true 时，取词将不可用
        ignored = ['video', 'audio', 'img', 'a'],
        ua = navigator.userAgent.toLowerCase();

    //Regular Expressing declaration
    var isEngWord = function(chars) {
        return (/^[a-zA-Z\-]+$/).test(chars);
    };

    //Highlight adding and removing
    var highlightTargetHtml = function() {
        console.log(range)
        content = range.extractContents();
        var node = highlightNode = document.createElement('span');
        node.className = 'hl';
        node.innerHTML = currentWord;
        range.insertNode(node);
    };

    var removeHighlight = function() {
        if (!range || !content || !highlightNode || !highlightNode.parentNode) {
            return;
        }
        // range.deleteContents();
        highlightNode.parentNode.removeChild(highlightNode); //上面的方法有兼容性问题
        range.insertNode(content);
        range = null;
    };


    var hideResult = function() {
        //加个这个 try catch 防止报错让程序不能正常运行
        // for  android  --> 可以点击空白消失 (ios不用做这样的处理)
        if (driver.closeNativeQueryWord) {
            driver.closeNativeQueryWord();
        }
        removeHighlight();
    };

    /**
     * get word by caretRangeFromPoint API
     * @param  {int} x
     * @param  {int} y
     * @return {string}
     */
    var getWord = function(x, y) {
        range = document.caretRangeFromPoint(x, y);
        if (!range) {
            return '';
        }

        range.expand("word");
        targetRealCoord.cx = range.getBoundingClientRect().left;
        targetRealCoord.cy = range.getBoundingClientRect().top;
        console.log(range.cloneContents().textContent)
        return range.cloneContents().textContent.trim();
    };

    /**
     * main function trigered to run them all~
     * @param  event
     */
    var mainDic = function(event) {

        if (!filterNode(event.target)) return;
        if(range) {
            hideResult()
            return
        }
        if (isDisabled) return;

        targetTouch = event.touches[0];
        targetCoord.px = targetTouch.pageX;
        targetCoord.py = targetTouch.pageY;
        targetCoord.cx = targetTouch.clientX;
        targetCoord.cy = targetTouch.clientY;
        var element = document.elementFromPoint(targetCoord.cx, targetCoord.cy);

        if(element.className.indexOf('pos') > -1 || element.className.indexOf('inline-icon') > -1) {
            event.stopPropagation();
            return;
        }
        if (ignored.indexOf(element.tagName.toLowerCase()) > -1) {
            event.stopPropagation();
            return;
        }

        currentWord = getWord(targetCoord.cx, targetCoord.cy);
        if (!isEngWord(currentWord) || element.innerText.indexOf(currentWord) < 0) {
            //no english or the word is not in the selected element
            range = null;
            return;
        }

        highlightTargetHtml();
        console.log(targetRealCoord.cx + highlightNode.offsetWidth / 2)
        console.log(targetRealCoord.cy + highlightNode.offsetHeight / 2)
        console.log(currentWord)
        exec({
            word: currentWord,
            pos: {
                x: Math.floor(targetRealCoord.cx + highlightNode.offsetWidth / 2),
                y: Math.floor(targetRealCoord.cy + highlightNode.offsetHeight / 2)
            }
        })
    };

    var tapHoldTriger = null,
        move = false,
        startE = null,
        init = function(mode) {
            var body = document.body;
            click = mode === 'click';
            driver = window.dict ? window.dict : {};

            body.addEventListener("touchstart", function(event) {
                hideResult();
                move = false;
                startE = event;
                if (!click) {
                    tapHoldTriger = setTimeout(function() {
                        mainDic(startE);
                    }, 500);
                }
            }, false);
            body.addEventListener("touchmove", function() {
                move = true;
                clearTimeout(tapHoldTriger);
            }, false);
            body.addEventListener("touchend", function() {

                clearTimeout(tapHoldTriger);
                if (!move && click) {
                    mainDic(startE);
                }
            }, false);

            var styleTag = document.createElement('style'),
                defaultCSS = ([
                    '.hl{',
                    'background-color: #3399dd;',
                    'color: #ffffff;',
                    '}'
                ]).join('\n');
            styleTag.id = 'catchword-style';
            styleTag.innerHTML = defaultCSS;
            document.querySelector('head').appendChild(styleTag);
        };

    //调用客户端接口进行查词
    var exec = function(opt) {
        opt.webViewWidth = window.innerWidth;
        opt.webViewHeight = window.innerHeight;

        if (/android/i.test(ua)) {
            //如果是android
            if (driver.queryWordNative) {
                driver.queryWordNative(
                    opt.word,
                    opt.pos.x / window.innerWidth,
                    opt.pos.y / window.innerHeight
                );
            }
        } else if (/ipad/i.test(ua) || /iphone/i.test(ua) || /ipod/i.test(ua)) {
            //如果是ios
            var str = JSON.stringify(opt);
            var url = 'youdaobs://word_capturing_for_ios/' + str;
            document.location = url;
        }
    }

    //检查当前用户点击的目标是否是a标签
    var filterNode = function(node) {
        var result = true;
        while (node != document.body) {
            if (node && node.tagName.toLowerCase() == "a") {
                result = false;
                break;
            } else {
                node = node.parentNode;
            }
        }
        return result;
    }

    window.catchWord = {
        init: init,
        setDisabled: function(val) {
            isDisabled = !!val;
        },
        hideResult: hideResult
    };
    init('click');
}());