package com.youdao.YDatabase;

import com.j256.ormlite.support.ConnectionSource;
import com.j256.ormlite.table.DatabaseTableConfig;
import com.j256.ormlite.table.TableUtils;

import java.sql.SQLException;
import java.util.List;

/**
 * Created by Yafei on 2015/1/8.
 */
public class YTableUtils {
    //一个和数据库的连接
    ConnectionSource connectionSource;

    /**
     * 构造函数
     * @param connectionSource
     */
    public YTableUtils(ConnectionSource connectionSource) {
        this.connectionSource = connectionSource;
    }

    public ConnectionSource getConnectionSource() {
        return connectionSource;
    }

    public void setConnectionSource(ConnectionSource connectionSource) {
        this.connectionSource = connectionSource;
    }

    /**
     * 建立一个Table
     * @param dataClass
     * @param <T>
     * @return
     * @throws SQLException
     */
    public <T> int createTable(Class<T> dataClass) throws SQLException{
        return TableUtils.createTable(connectionSource,dataClass);
    }

    /**
     * 建立一个Table
     * @param tableConfig
     * @param <T>
     * @return
     * @throws SQLException
     */
    public <T> int createTable(DatabaseTableConfig<T> tableConfig) throws SQLException{
        return TableUtils.createTable(connectionSource,tableConfig);
    }

    /**
     * 清除一个Table的数据
     * @param dataClass
     * @param <T>
     * @return
     * @throws SQLException
     */
    public <T> int clearTable(Class<T> dataClass) throws SQLException{
        return TableUtils.clearTable(connectionSource,dataClass);
    }

    /**
     * 清除一个Table的数据
     * @param tableConfig
     * @param <T>
     * @return
     * @throws SQLException
     */
    public <T> int clearTable(DatabaseTableConfig<T> tableConfig) throws SQLException{
        return TableUtils.clearTable(connectionSource,tableConfig);
    }

    /**
     * 在数据库中删除这个Table，可以选择是否报错，建议为false
     * @param dataClass
     * @param ignoreErrors
     * @param <T>
     * @return
     * @throws SQLException
     */
    public <T> int dropTable(Class<T> dataClass, boolean ignoreErrors) throws SQLException{
        return TableUtils.dropTable(connectionSource, dataClass, ignoreErrors);
    }

    /**
     * 在数据库中删除这个Table，可以选择是否报错，建议为false
     * @param tableConfig
     * @param ignoreErrors
     * @param <T>
     * @return
     * @throws SQLException
     */
    public <T> int dropTable(DatabaseTableConfig<T> tableConfig, boolean ignoreErrors) throws SQLException{
        return TableUtils.dropTable(connectionSource, tableConfig, ignoreErrors);
    }

    /**
     * 得到建立一个表格需要的SQL语句STRING列表
     * @param dataClass
     * @param <T>
     * @return
     * @throws SQLException
     */
    public <T> List<String> getCreateTableStatements(Class<T> dataClass) throws SQLException{
        return TableUtils.getCreateTableStatements(connectionSource, dataClass);
    }

    /**
     * 得到建立一个表格需要的SQL语句STRING列表
     * @param tableConfig
     * @param <T>
     * @return
     * @throws SQLException
     */
    public <T> List<String> getCreateTableStatements(DatabaseTableConfig<T> tableConfig) throws SQLException{
        return TableUtils.getCreateTableStatements(connectionSource, tableConfig);
    }
}
