/* eslint-disable */

window.ydk.config({
  debug: false,
  jsApiList: [
    'checkJsApi',
    'login',
    'isLogin',
    'ajax',
    'setTitle',
    'toggleMenu',
    'confirm',
    'onAnswerCardClicked',
    'showLoading',
    'hideLoading',
    'close',
    'configImgUpload',
    'multiPreviewImage',
    'uploadImgStart',
    'uploadImgEnd',
    'imgBottomViewHeight',
    'onBack',
    'toast',
    'practiceLogin',
    'share',
    'onShareClicked',

    // 播放音频
    'playVoice',
    'pauseVoice',
    'stopVoice',
    'onVoicePause',
    'onVoiceStart',
    'onVoicePlayEnd',
    'onVoicePlayProgress',
    'configAudioPlayerRate',

    // 播放视频
    'playVideo',

    // 纠音题型相关
    'popupRecord',
    'onRecordClose',

    // push相关
    'openPush',

    // 跳转至课程详情页
    'openCourseDetail',

    // 写作题
    'write',
    'ocr',
  ]
})

window.ydk.extend({
  /**
   * 测试系统：设置页面标题
   */
  setTitle: function(params){
    window.ydk._invoke('setTitle', {
      title: params.title,
    }, params);
  },

  /**
   * 测试系统：调用系统confirm
   */
   confirm: function(params){
    window.ydk._invoke('confirm', {
      msg: params.msg,
      ok: params.ok,
      cancel: params.cancel
    } , params);
  },

  // 主动唤起客户端登录(TODO:ydk.login传参一直失效，而这里要告诉客户端是从测试页面唤起登录，遂定制此方法)
  practiceLogin: function(params){
    window.ydk._invoke('practiceLogin', {} , params);
  },

  /**
   * 测试系统：调用系统loading
   */
   showLoading: function(params){
    window.ydk._invoke('showLoading', {
      msg: params.msg,
    } , params);
  },

  /**
   * 测试系统：隐藏系统 loading
   */
   hideLoading: function(params){
    window.ydk._invoke('hideLoading', {} , params);
  },

  /**
   * 测试系统：关闭当前窗口
   */
  close: function(params){
    window.ydk._invoke('close', {} , params);
  },

  /*
  * 测试系统: 调起客户端拍照上传弹窗
  */
  configImgUpload: function (params) {
    window.ydk._invoke('configImgUpload', {
      id: params.id,
      storeId: params.storeId,
      imgList: params.imgList,
      isEssay: params.isEssay,
      bottom: params.bottom,
    }, params)
  },

  /*
  * 测试系统: 调起多图预览
  */
  multiPreviewImage: function (params) {
    window.ydk._invoke('multiPreviewImage', {
      imgList: params.imgList,
      imgClickIndex: params.imgClickIndex,
    }, params)
  },

  /**
   * 客户端开始上传图片回调
   */
  uploadImgStart: function (params) {
    window.ydk._on('uploadImgStart', {}, params)
  },

  /**
   * 客户端上传图片完成回调
   */
  uploadImgEnd: function (params) {
    window.ydk._on('uploadImgEnd', {}, params)
  },

  /**
   * 客户端点击答题卡入口回调
   */
  onAnswerCardClicked: function(params){
    window.ydk._on('onAnswerCardClicked', {} , params);
    window._rlog.push(['_trackEvent', 'test/answersheet'])
  },

  /**
   * 客户端点击返回按钮回调
   */
   onBack: function(params){
    window.ydk._on('onBack', {} , params);
  },

  /**
   * 客户端告知前端拍照上传view高度
   */
  imgBottomViewHeight: function (params) {
    window.ydk._on('imgBottomViewHeight', {}, params)
  },

  // 通知客户端弹出“开启系统通知弹窗”
  openPush: function(params) {
    window.ydk._invoke('openPush', {}, params)
  },

  // 隐藏右上角菜单
  // 参数：hidden: true / false
  toggleMenu: function(params) {
    ydk._invoke('toggleMenu', params)
  },

  // 右上角分享按钮被点击的回调
  onShareClicked: function (params) {
    window.ydk._on('onShareClicked', {}, params);
  },

  // 调起客户端录音弹窗
  popupRecord: function (params) {
    ydk._invoke('popupRecord', params, params)
  },

  // 监听客户端录音弹窗关闭（客户端将questionId, storeId, audioUrl, duration, result返回）
  onRecordClose: function (params) {
    window.ydk._on('onRecordClose', {}, params)
  },

  // 播放视频
  playVideo: function (params) {
    ydk._invoke('playVideo', {
      url: params.url,
      title: params.title,
    }, params)
  },

  // 音频变速
  configAudioPlayerRate: function (params) {
    ydk._invoke('configAudioPlayerRate', {
      rate: params.rate,
    }, params)
  },

  // 打开课程详情页。因客户端特殊操作不能使用 schemaUrl
  openCourseDetail: function (params) {
    ydk._invoke('openCourseDetail', params, params)
  },

  // 调起 ocr 拍照识别
  ocr: function (params) {
    ydk._invoke('ocr', params, params)
  },

  // 调起一个手写输入框
  write: function (params) {
    ydk._invoke('write', params, params)
  },
})
/* eslint-enable */
