/* eslint-disable */

ydk.config({
  debug: false,
  jsApiList: [
    'checkJsApi',
    'login',
    'isLogin',
    'ajax',
    'setTitle',
    'showAnswerCardEntry',
    'hideAnswerCardEntry',
    'confirm',
    'onAnswerCardClicked',
    'showLoading',
    'hideLoading',
    'close',
    'configImgUpload',
    'multiPreviewImage',
    'uploadImgStart',
    'uploadImgEnd',
    'imgBottomViewHeight',
    'onBack',
    'toast',
    'alert',
    'practiceLogin',
    'storageSetItem',
    'storageGetItem',
    'share',

    // 纠音题型相关
    'popupRecord',
    'onRecordClose',

    // 背诵题型相关
    'recitationRecord',
    'popupBottomTextarea',

    // 播放音频
    'playVoice',
    'pauseVoice',
    'stopVoice',
    'onVoicePause',
    'onVoiceStart',
    'onVoicePlayEnd',
    'onVoicePlayProgress',
    'configAudioPlayerRate',

    // 播放视频
    'playVideo',

    // 刷新页面
    'reloadPage',

    // 写作题
    'write',
    'ocr',
  ]
})


ydk.extend({
  /**
   * 测试系统：设置页面标题
   * 参数 title：页面标题
   * 参数 showLine：是否显示标题栏下方的一条线
   */
  setTitle: function(params){
    ydk._invoke('setTitle', {
      title: params.title,
      showLine: params.showLine,
    }, params);
  },


  /**
   * 测试系统：展示答题卡入口
   */
   showAnswerCardEntry: function(params){
    ydk._invoke('showAnswerCardEntry', {} , params);
  },


  /**
   * 测试系统：隐藏答题卡入口
   */
   hideAnswerCardEntry: function(params){
    ydk._invoke('hideAnswerCardEntry', {} , params);
  },

  /**
   * 测试系统：调用系统confirm
   */
   confirm: function(params){
    ydk._invoke('confirm', {
      msg: params.msg,
      ok: params.ok,
      cancel: params.cancel
    } , params);
  },

  alert: function(params) {
    ydk._invoke('alert', {
      msg: params.msg,
      ok: params.ok,
      onOk: params.onOk
    } , params);
  },

  // 唤起客户端登录
  // 与普通 login 不同的是，该方法登陆成功后会刷新页面
  practiceLogin: function(params){
    ydk._invoke('practiceLogin', {} , params);
  },

  /**
   * 测试系统：调用系统loading
   */
   showLoading: function(params){
    ydk._invoke('showLoading', {
      msg: params.msg,
    } , params);
  },

  /**
   * 测试系统：隐藏系统 loading
   */
   hideLoading: function(params){
    ydk._invoke('hideLoading', {} , params);
  },


  /**
   * 测试系统：关闭当前窗口
   */
  close: function(params){
    ydk._invoke('close', {} , params);
  },

  /*
  * 测试系统: 调起客户端拍照上传弹窗
  */
  configImgUpload: function (params) {
    ydk._invoke('configImgUpload', {
      id: params.id,
      storeId: params.storeId,
      imgList: params.imgList,
      isEssay: params.isEssay,
      bottom: params.bottom,
    }, params)
  },

  /*
  * 测试系统: 调起多图预览
  */
  multiPreviewImage: function (params) {
    window.ydk._invoke('multiPreviewImage', {
      imgList: params.imgList,
      imgClickIndex: params.imgClickIndex,
    }, params)
  },

  /**
   * 客户端开始上传图片回调
   */
  uploadImgStart: function (params) {
    window.ydk._on('uploadImgStart', {}, params)
  },

  /**
   * 客户端上传图片完成回调
   */
  uploadImgEnd: function (params) {
    window.ydk._on('uploadImgEnd', {}, params)
  },

  /**
   * 客户端点击答题卡入口回调
   */
  onAnswerCardClicked: function(params){
    ydk._on('onAnswerCardClicked', {} , params);
    window._rlog.push(['_trackEvent', 'test/answersheet'])
  },


  /**
   * 客户端点击返回按钮回调
   */
   onBack: function(params){
    ydk._on('onBack', {} , params);
  },

  /**
   * 客户端告知前端拍照上传view高度
   */
  imgBottomViewHeight: function (params) {
    window.ydk._on('imgBottomViewHeight', {}, params)
  },

  /**
   * 本地存储
   */
   storageGetItem: function(params){
    ydk._invoke('storageGetItem', {
      key: params.key,
    } , params);
  },


  /**
   * 本地存储
   */
   storageSetItem: function(params){
    ydk._invoke('storageSetItem', {
      key: params.key,
      value: params.value,
    }, params);
  },

  // 调起客户端录音弹窗
  popupRecord: function(params) {
    ydk._invoke('popupRecord', params, params)
  },

  // 监听客户端录音弹窗关闭（客户端将questionId, storeId, audioUrl, duration, result返回）
  onRecordClose: function(params) {
    window.ydk._on('onRecordClose', {}, params)
  },

  // 播放视频
  playVideo: function (params) {
    ydk._invoke('playVideo', {
      url: params.url,
      title: params.title,
    }, params)
  },

  // 音频变速
  configAudioPlayerRate: function (params) {
    ydk._invoke('configAudioPlayerRate', {
      rate: params.rate,
    }, params)
  },

  // 调起背诵题弹窗
  recitationRecord: function (params) {
    ydk._invoke('recitationRecord', params, params)
  },

  // 调起通用底部弹窗
  popupBottomTextarea: function (params) {
    ydk._invoke('popupBottomTextarea', params, params)
  },

  // 刷新页面（前端在客户端 webview 中很可能没有 reload 权限
  reloadPage: function () {
    ydk._invoke('reloadPage')
  },

  // 调起 ocr 拍照识别
  ocr: function (params) {
    ydk._invoke('ocr', params, params)
  },

  // 调起一个手写输入框
  write: function (params) {
    ydk._invoke('write', params, params)
  },
})
/* eslint-enable */
